import * as elements from '@yellicode/elements';
import { ClassDefinition, InterfaceDefinition, EnumDefinition, PropertyDefinition, AccessModifier, FunctionDefinition } from './model';
import * as opts from './options';
import { TypeNameProvider } from '@yellicode/templating';
export declare class DefinitionBuilder {
    private typeNameProvider;
    constructor(typeNameProvider: TypeNameProvider);
    buildClassDefinition(type: elements.Type, options?: opts.ClassOptions): ClassDefinition;
    buildInterfaceDefinition(type: elements.Type, options?: opts.InterfaceOptions): InterfaceDefinition;
    buildEnumDefinition(type: elements.Type, options?: opts.EnumOptions): EnumDefinition;
    buildFunctionDefinition(op: elements.Operation, options?: opts.FunctionOptions): FunctionDefinition;
    private buildParameterDefinition(p, features, optionalityModifier);
    buildPropertyDefinition(property: elements.Property, options?: opts.PropertyOptions): PropertyDefinition;
    private static buildImplements(cls, additional);
    private static buildExtends(type, additional);
    private static buildDescription(type);
    static getDefaultValueString(element: elements.MultiplicityElement, tsTypeName: string | null, defaultValue: elements.ValueSpecification | null, isOptional: boolean, optionalityModifier: opts.OptionalityModifier, initializePrimitiveType?: boolean, initializeArray?: boolean): string | undefined;
    private getFullTypeName(typedElement, fallback?);
    static getAccessModifierString(visibility: elements.VisibilityKind | null): AccessModifier | undefined;
}
